<script setup lang="ts">
import vueMultiselect from 'vue-multiselect'

export interface OptionType {
  id: number
  name: string
  code: string
  select: boolean
}

// const props = defineProps({
//   options: {
//     type: Array as PropType<OptionType[]>,
//     default: () => [
//       { name: 'test1', code: 'test1', select: false },
//       { name: 'test2', code: 'test2', select: false },
//       { name: 'test3', code: 'test3', select: false },
//       { name: 'test4', code: 'test4', select: false },
//       { name: 'test5', code: 'test5', select: false },
//       { name: 'test6', code: 'test6', select: false }
//     ]
//   }
// })

const options = ref([
  { id: 0, name: 'test1', code: 'test1', select: false, style: false },
  { id: 1, name: 'test2', code: 'test2', select: false, style: false },
  { id: 2, name: 'test3', code: 'test3', select: false, style: false },
  { id: 3, name: 'test4', code: 'test4', select: false, style: false },
  { id: 4, name: 'test5', code: 'test5', select: false, style: false },
  { id: 5, name: 'test6', code: 'test6', select: false, style: false },
  { id: 6, name: 'test7', code: 'test7', select: false, style: false },
  { id: 7, name: 'test8', code: 'test8', select: false, style: false }
])

const isActive = ref(false)
const selectValue = ref()

const limit = ref(4)
const limitLength = ref(0)

function selectChange(event: OptionType) {
  if (event) {
    isActive.value = true
    selectValue.value.select = true

    const findSelectOption = options.value.find(
      (item) => item.code === event.code
    )

    if (findSelectOption) {
      findSelectOption.select = true
    }

    sortOptionsList()
    countLimitLength()
  }
}

function removeChange(event: OptionType) {
  if (event) {
    const findRemoveOption = options.value.find(
      (item) => item.code === event.code
    )
    if (findRemoveOption) {
      findRemoveOption.select = false
    }
  }

  sortOptionsList()
  emitValue()
}

function sortOptionsList() {
  const trueList = options.value
    .filter((item) => item.select)
    .sort((a, b) => a.id - b.id)

  if (trueList.length) {
    trueList.forEach((item) => {
      item.style = false
    })

    trueList[trueList.findLastIndex((item) => item.code)].style = true
  }

  const falseList = options.value
    .filter((item) => !item.select)
    .sort((a, b) => a.id - b.id)

  falseList.forEach((item) => {
    item.style = false
  })

  options.value = trueList.concat(falseList)
}

function countLimitLength() {
  console.log(selectValue.value.length)
  limitLength.value = selectValue.value.length - limit.value
}

function removeStyle() {
  isActive.value = Object.values(selectValue.value ?? '').length ? true : false
}

const emit = defineEmits<{
  (event: 'update:modelValue', value: OptionType[]): void
}>()

function emitValue(): void {
  emit('update:modelValue', selectValue.value)
}
</script>

<template>
  <div :class="{ active: isActive }" class="multiselect">
    <vue-multiselect
      v-model="selectValue"
      :limit="limit"
      :multiple="true"
      :option-height="104"
      :options="options"
      :searchable="false"
      :show-labels="false"
      :taggable="true"
      label="name"
      placeholder="請選擇"
      track-by="code"
      @close="removeStyle(), emitValue()"
      @open="isActive = true"
      @remove="removeChange($event)"
      @select="selectChange($event)"
    >
      <template #option="slotData">
        <span class="option__title">
          <div class="form-check">
            <input
              :id="slotData.option.code"
              v-model="slotData.option.select"
              class="form-check-input"
              type="checkbox"
            />
            <label class="form-check-label">
              {{ slotData.option.name }}
            </label>
          </div>
        </span>

        <hr v-if="slotData.option.style" />
      </template>

      <template #limit>
        <div class="limit-group">
          <span class="limit-symbol">...</span>
          <span class="limit-number">{{ limitLength }}</span>
        </div>
      </template>
    </vue-multiselect>
  </div>
</template>

<style lang="scss" scoped>
.multiselect {
  width: 100%;
  ::v-deep .multiselect__tags {
    display: flex;
    align-items: center;
    height: 48px;
    padding: 0 40px 0 24px;
    background-color: #efefef;
    border: 1px solid #efefef;
    border-radius: 24px;

    .multiselect__tags-wrap {
      display: flex;

      .multiselect__tag {
        display: flex;
        align-items: center;
        height: 32px;
        margin: 0 10px 0 0;
        font-size: 16px;
        color: #046db6;
        background: rgb(55 92 166 / 10%);
        border-radius: 16px;

        .multiselect__tag-icon {
          display: flex;
          align-items: center;

          &::after {
            position: absolute;
            top: 25%;
            content: url("@/assets/icons/x.svg");
          }
        }
      }
    }

    .multiselect__placeholder {
      margin: 0;
      color: #111111;
    }
  }

  ::v-deep .multiselect {
    border: 1px solid transparent;
    .multiselect__placeholder {
      font-size: 16px;
      font-style: normal;
      font-weight: 400;
      line-height: 150%;
      letter-spacing: 0.02em;
    }
    .multiselect__select {
      height: 16px;
      width: 16px;
      top: 16px;
      right: 18px;
      background-image: url('@/assets/icons/chevron-down-gray.svg');
      background-size: 16px 16px;
      transition: 0.3s;
      &::before {
        content: none;
      }
    }
    .multiselect__content-wrapper {
      top: 48px;
      height: 430px;
      border: 1px solid transparent;
      border-radius: 24px;
      box-shadow: 0 4px 40px rgba(4, 30, 66, 0.2);
    }
  }

  ::v-deep .multiselect--active {
    .multiselect__tags {
      background-color: #fff;
      border: 1px solid #046db6;
      border-radius: 24px;
      box-shadow: 0 0 20px rgb(45 20 2 / 26%);
    }
    .multiselect__placeholder {
      display: block;
    }
  }
  ::v-deep .multiselect__content {
    padding: 24px;

    .multiselect__element {
      .multiselect__option {
        display: unset;
        padding: 0;

        .option__title {
          display: block;
          padding: 12px;

          &:hover {
            color: #333;
            background: rgb(55 92 166 / 10%);
            border-radius: 8px;
          }

          .form-check {
            display: flex;
            align-items: center;
            padding: 0;

            .form-check-input {
              margin: 0 8px 0 0;
              cursor: pointer;

              &:checked {
                background-color: #046db6;
                border-color: #046db6;
              }

              &:focus {
                box-shadow: none;
              }
            }

            .form-check-label {
              cursor: pointer;
            }
          }
        }

        &.multiselect__option--selected {
          font-weight: normal;
          color: #333;
          background: #fff;
        }

        &.multiselect__option--highlight {
          color: #333;
          background: rgb(55 92 166 / 10%);
        }
      }

      &.select {
        margin-bottom: 20px;
        border-bottom: 1px solid #e5e5e5;

        .multiselect__option {
          margin-bottom: 20px;
        }
      }
    }
  }

  &.active {
    border: 1px solid #046db6;
    border-radius: 24px;
    ::v-deep .multiselect__tags {
      height: 48px;
      background-color: #fff;
      border-radius: 24px;
    }
  }

  ::v-deep hr {
    margin: 20px 0;
  }

  .limit-group {
    display: flex;
    .limit-symbol {
      margin-bottom: 5px;
      font-weight: bold;
      color: #046db6;
    }

    .limit-number {
      position: absolute;
      top: 20%;
      right: 8%;
      padding: 4px 10px;
      color: #046db6;
      background: rgb(55 92 166 / 10%);
      border-radius: 15px;
    }
  }
}
</style>
